makePGFenv <- function(pgffile, clffile){
  counter <- 1
  con <- file(pgffile, "r")
  pgf <- data.frame(probesetID       = integer(),
                    probesetType     = character(),
                    atomID           = integer(),
                    probeID          = integer(),
                    probetype        = integer(),
                    strand           = integer(),
                    gcCount          = integer(),
                    length           = integer(),
                    interrogation    = integer(),
                    sequence         = character(),
                    stringsAsFactors = FALSE)
  parsed <- names(pgf)
  cat(parsed, "\n", file=paste(pgffile, ".parsed", sep=""), append=TRUE)
  tmp <- strsplit(readLines(con, n=1), "\t")[[1]]
  while(length(tmp)>0){
    if (length(tmp) != 1){
      if(tmp[1] != ""){
        ## probeset_id and type of probeset
        probesetIDtype <- tmp
      }else if(tmp[1] == "" & tmp[2] != ""){
        atomID <- as.integer(tmp[-1])
      }else if(all(tmp[1:2]=="")){
        tmp <- tmp[-c(1,2)]
        if(tmp[2] == "pm:st"){
          type <- strand <- as.integer(1)
        }else if(tmp[2] == "pm:at"){
          type <- as.integer(1)
          strand <- as.integer(0)
        }else if(tmp[2] == "mm:st"){
          type <- as.integer(0)
          strand <- as.integer(1)
        }else if(tmp[2] == "mm:at"){
          type <- strand <- as.integer(0)
        }else{
          type <- strand <- as.integer(-1)
        }

        for (i in 1:length(atomID)){
          parsed <- c(as.integer(probesetIDtype[1]),
                      probesetIDtype[2],
                      atomID[i],
                      as.integer(tmp[1]),
                      type,
                      strand,
                      as.integer(tmp[3]),
                      as.integer(tmp[4]),
                      as.integer(tmp[5]),
                      tmp[6])
          cat(parsed, "\n", file=paste(pgffile, ".parsed", sep=""), append=TRUE)
        }
      }
    }
    if (counter %% 1000000 == 0) cat(".")
    tmp <- readLines(con, n=1)
    if(length(tmp)>0)
      tmp <- strsplit(tmp, "\t")[[1]]
    counter <- counter+1
  }
  close(con)
  pgf <- read.table(paste(pgffile, ".parsed", sep=""), as.is=TRUE, header=TRUE); gc()
  clf <- read.table(clffile)
  names(clf) <- c("probeID", "x", "y")
  idx <- match(clf$probeID, pgf$probeID)
  clf$probesetID    <- NA
  clf$probesetType  <- NA
  clf$atomID        <- NA
  clf$probeID2      <- NA
  clf$probetype     <- NA
  clf$strand        <- NA
  clf$gcCount       <- NA
  clf$length        <- NA
  clf$interrogation <- NA
  clf$sequence      <- NA
  clf[!is.na(idx), -c(1:3)] <- pgf[idx[!is.na(idx)],]
  clf$probesetType <- as.character(tmp$probesetType)

  ## this is not 100% correct, ignoring all controls
  clf$probetype[clf$probesetType != "main"] <- NA
  clf$probesetType <- NULL
  clf$probeID2 <- NULL
  clf$sequence <- as.character(tmp$sequence)

  names(clf) <- c("feature_ID", "X", "Y", "feature_set_name",
                  "atomID", "feature_type", "target_strand",
                  "gc_count", "length", "location", "sequence")
  idx <- clf$feature_type == 1
  clf$feature_type[idx] <- "PM"
  clf$feature_type[!idx] <- "MM"
  idx <- clf$target_strand == 1
  clf$target_strand[idx] <- "sense"
  clf$target_strand[!idx] <- "antisense"
  clf$order_index <- 1:nrow(clf)
  clf <- clf[order(clf$feature_set_name, clf$feature_type, clf$target_strand, clf$location),]
  new("platformDesign",
      featureInfo=assign2env(clf),
      manufacturer="Affymetrix",
      type="exon",
      nrow=2560,
      ncol=2560)
}
